    001    /*
    002     * Copyright (c) 2007-2014 Concurrent, Inc. All Rights Reserved.
    003     *
    004     * Project and contact information: http://www.cascading.org/
    005     *
    006     * This file is part of the Cascading project.
    007     *
    008     * Licensed under the Apache License, Version 2.0 (the "License");
    009     * you may not use this file except in compliance with the License.
    010     * You may obtain a copy of the License at
    011     *
    012     *     http://www.apache.org/licenses/LICENSE-2.0
    013     *
    014     * Unless required by applicable law or agreed to in writing, software
    015     * distributed under the License is distributed on an "AS IS" BASIS,
    016     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017     * See the License for the specific language governing permissions and
    018     * limitations under the License.
    019     */
    020
    021    package cascading.flow.stream;
    022
    023    /**
    024     *
    025     */
    026    public abstract class Gate<Incoming, Outgoing> extends Duct<Incoming, Outgoing>
    027      {
    028      protected Duct[] allPrevious;
    029
    030      public Gate()
    031        {
    032        }
    033
    034      @Override
    035      public void bind( StreamGraph streamGraph )
    036        {
    037        super.bind( streamGraph ); // sets next
    038
    039        allPrevious = getAllPreviousFor( streamGraph );
    040        }
    041
    042      /**
    043       * the actual previous in this context, not necessarily the declared previous
    044       *
    045       * @param streamGraph of type StreamGraph
    046       * @return of type Duct[]
    047       */
    048      protected Duct[] getAllPreviousFor( StreamGraph streamGraph )
    049        {
    050        return streamGraph.findAllPreviousFor( this );
    051        }
    052      }